#include <stdio.h>
#include <stdlib.h>


int foo1(int a, int b, int c, int x, int *n) {
  /* izracunaj izraz iz zadatka i spremi mu vrijednost u x */
  x = (a * x - b) * x + c;
  if (x < 0) x = -x;
  /* ako smo dobili NULL-pointer kao n, zakaci se npr. za c */
  if (!n) n = &c;
  /* *n treba biti 1 ako je x == 0 -- jedna parna znamenka */
  *n = (x == 0);
  /* u b spremaj trenutnu sumu parnih znamenaka, u a trenutnu znamenku */
  for (b = 0; x; x /= 10) {
    a = x % 10;
    /* ako je trenutna znamenka parna... */
    if (!(a % 2)) {
      b += a;
      ++*n;
    }
  }
  return b;
}


int bar1(int a, int b, int c, int x, int *n) {
  x = (b * x + c) * x * x + a;
  if (x < 0) x = -x;
  if (!n) n = &c;
  *n = (x == 0);
  for (b = 1; x; x /= 10) {
    a = x % 10;
    if (!(a % 2)) {
      b *= a;
      ++*n;
    }
  }
  return b;
}


int foo2(int a, int b, int c, int x, int *n) {
  x = (c * x * x + a * x - b) * x;
  if (x < 0) x = -x;
  if (!n) n = &c;
  *n = 0;
  for (b = 0; x; x /= 10) {
    a = x % 10;
    if (a % 2) {
      b += a;
      ++*n;
    }
  }
  return b;
}


int bar2(int a, int b, int c, int x, int *n) {
  x = (c * x * x - b) * x + a;
  if (x < 0) x = -x;
  if (!n) n = &c;
  *n = 0;
  for (b = 1; x; x /= 10) {
    a = x % 10;
    if (a % 2) {
      b *= a;
      ++*n;
    }
  }
  return b;
}


int main(void) {
  int a = 17, b = 19, c = 23, x = 3, n;
  printf("foo1(%d, %d, %d, %d)=(%d, %d)\n", a, b, c, x, foo1(a, b, c, x, &n), n);
  printf("bar1(%d, %d, %d, %d)=(%d, %d)\n", a, b, c, x, bar1(a, b, c, x, &n), n);
  printf("foo2(%d, %d, %d, %d)=(%d, %d)\n", a, b, c, x, foo2(a, b, c, x, &n), n);
  printf("bar2(%d, %d, %d, %d)=(%d, %d)\n", a, b, c, x, bar2(a, b, c, x, &n), n);
  return EXIT_SUCCESS;
}
