#include <stdio.h>

void izracunajAB( int n, int *a, int *b )
{
	*a = 0; *b = 0;
	
	while( n % 2 == 0 )
	{
		++(*a);
		n /= 2;
	}	
	
	while( n % 3 == 0 )
	{
		++(*b);
		n /= 3;
	}	
}

int sretan( int n )
{
	int a, b, produkt, produktNaopako, produktKopija;
	
	izracunajAB( n, &a, &b );
	
	if( a > 0 && b > 0 )
	{
		produkt = produktKopija = a * b;
		produktNaopako = 0;
		
		while( produktKopija > 0 )
		{
			produktNaopako = 10 * produktNaopako + ( produktKopija % 10 );
			produktKopija /= 10;
		}
		
		if( produkt == produktNaopako )
			return 1;
	}
	
	return 0;
}

int main( void )
{
	int x, y, n;
	
	scanf( "%d%d", &x, &y );
	for( n = x; n <= y; ++n )
		if( sretan( n ) )
			printf( "%d ", n ); 

	return 0;
}
