#include <stdio.h>

void izracunajAB( int n, int *a, int *b )
{
	*a = 0; *b = 0;
	
	while( n % 3 == 0 )
	{
		++(*a);
		n /= 3;
	}	
	
	while( n % 5 == 0 )
	{
		++(*b);
		n /= 5;
	}	
}

int razdragan( int n )
{
	int a, b;
	
	izracunajAB( n, &a, &b );
	
	if( a > 0 && b > 0 )
	{
		int minA = 9, maxB = 0;
		while( a > 0 )
		{
			if( a % 10 < minA )
				minA = a % 10;
			
			a /= 10; 
		}
		
		while( b > 0 )
		{
			if( b % 10 > maxB )
				maxB = b % 10;
			
			b /= 10; 
		}
		
		if( minA > maxB )
			return 1;
	}
	
	return 0;
}

int main( void )
{
	int m, n, koliko = 0;
	
	scanf( "%d", &m );
	for( n = 1; n <= m; ++n )
		if( razdragan( n ) )
			++koliko;
			
	printf( "%d\n", koliko ); 

	return 0;
}
